diff -ruN ../nakedmudv3.1/src/olc2/olc.c src/olc2/olc.c
--- ../nakedmudv3.1/src/olc2/olc.c	Sun Dec  4 20:03:07 2005
+++ src/olc2/olc.c	Sat Jul  1 20:06:58 2006
@@ -17,6 +17,13 @@
 #include "../world.h"
 #include "../character.h"  // for POS_XXX <-- we should change the place of this
 #include "../auxiliary.h"
+#include "../prototype.h"
+#include "../zone.h"
+#include "../room_reset.h"
+#include "../room.h"
+#include "../handler.h"
+#include "../object.h"
+#include "../inform.h"
 #include "olc.h"
 
 
@@ -247,11 +254,307 @@
 
 
 //*****************************************************************************
+// builder commands
+//*****************************************************************************
+
 //
-// implementation of olc.h
+// Load a copy of a specific mob/object
+// usage: load <mob | obj> <vnum>
+COMMAND(cmd_load) {
+  if(!arg || !*arg)
+    send_to_char(ch, "What did you want to load?\r\n");
+  else {
+    char   type[SMALL_BUFFER];
+    char   name[SMALL_BUFFER];
+    char locale[SMALL_BUFFER];
+    char    key[SMALL_BUFFER];
+    arg = one_arg(arg, type);
+    if(!parse_worldkey_relative(ch, arg, name, locale)) {
+      send_to_char(ch, "What did you want to load?\r\n");
+      return;
+    }
+
+    sprintf(key, "%s@%s", name, locale);
+    if(!strncasecmp("mobile", type, strlen(type))) {
+      PROTO_DATA *proto = worldGetType(gameworld, "mproto", key);
+      if(proto == NULL)
+	send_to_char(ch, "No mobile prototype exists with that key.\r\n");
+      else if(protoIsAbstract(proto))
+	send_to_char(ch, "That prototype is abstract.\r\n");
+      else {
+	CHAR_DATA *mob = protoMobRun(proto);
+	if(mob == NULL)
+	  send_to_char(ch, "There was an error running the prototype.\r\n");
+	else {
+	  send_to_char(ch, "You create %s.\r\n", charGetName(mob));
+	  char_to_room(mob, charGetRoom(ch));
+	}
+      }
+    }
+
+    else if(!strncasecmp("object", type, strlen(type))) {
+      PROTO_DATA *proto = worldGetType(gameworld, "oproto", key);
+      if(proto == NULL)
+	send_to_char(ch, "No object prototype exists with that key.\r\n");
+      else if(protoIsAbstract(proto))
+	send_to_char(ch, "That prototype is abstract.\r\n");
+      else {
+	OBJ_DATA *obj = protoObjRun(proto);
+	if(obj == NULL)
+	  send_to_char(ch, "There was an error running the prototype.\r\n");
+	else {
+	  send_to_char(ch, "You create %s.\r\n", objGetName(obj));
+	  obj_to_char(obj, ch);
+	}
+      }
+    }
+
+    // type not found
+    else 
+      send_to_char(ch, "What type of thing did you want to load?\r\n");
+  }
+}
+
+
+//
+// remove an object or player from the game. If no argument is supplied, all
+// objects and non-player characters are removed from the current room.
+//   usage: purge <target>
+COMMAND(cmd_purge) {
+  void    *found = NULL;
+  int found_type = PARSE_NONE;
+
+  if(!parse_args(ch, TRUE, cmd, arg, "| { ch.room.noself obj.room }",
+		 &found, &found_type))
+    return;
+
+  // purge everything in the current room
+  if(found == NULL) {
+    LIST_ITERATOR *list_i = newListIterator(roomGetContents(charGetRoom(ch)));
+    OBJ_DATA *obj;
+    CHAR_DATA *vict;
+
+    send_to_char(ch, "You purge the room.\r\n");
+    message(ch, NULL, NULL, NULL, FALSE, TO_ROOM,
+	    "$n raises $s arms, and white flames engulf the entire room.");
+
+    // purge all the objects. 
+    ITERATE_LIST(obj, list_i)
+      extract_obj(obj);
+    deleteListIterator(list_i);
+
+    // and now all of the non-characters
+    list_i = newListIterator(roomGetCharacters(charGetRoom(ch)));
+    ITERATE_LIST(vict, list_i) {
+      if(vict == ch || !charIsNPC(vict)) 
+	continue;
+      extract_mobile(vict);
+    }
+    deleteListIterator(list_i);
+  }
+
+  // purge characters
+  else if(found_type == PARSE_CHAR) {
+    // we can only purge him if we have all the same groups as him, and more
+    if(!charHasMoreUserGroups(ch, found))
+      send_to_char(ch, "Erm, you better not try that on %s. %s has "
+		   "just as much priviledges as you.\r\n", 
+		   HIMHER(found), HESHE(found));
+    else {
+      send_to_char(ch, "You purge %s.\r\n", charGetName(found));
+      message(ch, found, NULL, NULL, FALSE, TO_ROOM,
+	      "$n raises $s arms, and white flames engulf $N.");
+      extract_mobile(found);
+    }
+  }
+
+  // purge objects
+  else if(found_type == PARSE_OBJ) {
+    send_to_char(ch, "You purge %s.\r\n", objGetName(found));
+    message(ch, NULL, found, NULL, FALSE, TO_ROOM,
+	    "$n raises $s arms, and white flames engulf $o.");
+    obj_from_room(found);
+    extract_obj(found);
+  }
+}
+
+
 //
+// reruns the room's load script, and replaces the old version of the room with
+// the new one.
+COMMAND(cmd_rreload) {
+  PROTO_DATA   *proto = NULL;
+  ROOM_DATA *old_room = NULL;
+  ROOM_DATA *new_room = NULL;
+  ZONE_DATA     *zone = NULL;
+  const char     *key = roomGetClass(charGetRoom(ch));
+
+  // unless an arg is supplied, we're working on the current room.
+  if(arg && *arg)
+    key = get_fullkey_relative(arg, get_key_locale(key));
+
+  // make sure all of our requirements are met
+  if( (zone = worldGetZone(gameworld, get_key_locale(key))) == NULL)
+    send_to_char(ch, "That zone does not exist!\r\n");
+  else if(!canEditZone(zone, ch))
+    send_to_char(ch, "You are not authorized to edit that zone.\r\n");
+  else if( (proto = worldGetType(gameworld, "rproto", key)) == NULL)
+    send_to_char(ch, "No prototype for that room exists.\r\n");
+  else if(!worldRoomLoaded(gameworld, key))
+    send_to_char(ch, "No room with that key is currently loaded.\r\n");
+  else {
+    // try running the proto to get our new room...
+    old_room = worldGetRoom(gameworld, key);
+    new_room = protoRoomRun(proto);
+    if(new_room == NULL)
+      send_to_char(ch, "There was an error reloading the room.\r\n");
+    else {
+      do_mass_transfer(old_room, new_room, TRUE, TRUE, TRUE);
+      extract_room(old_room);
+      worldPutRoom(gameworld, key, new_room);
+      send_to_char(ch, "Room reloaded.\r\n");
+    }
+  }
+}
+
+
+//
+// trigger all of a specified zone's reset scripts and such. If no vnum is
+// supplied, the zone the user is currently in is reset.
+//   usage: zreset <zone vnum>
+COMMAND(cmd_zreset) {
+  ZONE_DATA *zone = NULL;
+
+  if(!arg || !*arg)
+    zone= worldGetZone(gameworld,get_key_locale(roomGetClass(charGetRoom(ch))));
+  else
+    zone= worldGetZone(gameworld, arg);
+
+  if(zone == NULL)
+    send_to_char(ch, "Which zone did you want to reset?\r\n");
+  else if(!canEditZone(zone, ch))
+    send_to_char(ch, "You are not authorized to edit that zone.\r\n");
+  else {
+    send_to_char(ch, "%s has been reset.\r\n", zoneGetName(zone));
+    zoneForceReset(zone);
+  }
+}
+
+COMMAND(cmd_rdelete) {
+  char *name = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word", &name))
+    return;
+  if(do_delete(ch, "rproto", deleteProto, name)) {
+    do_delete(ch, "reset", deleteResetList, name);
+    send_to_char(ch, "If the room has already been used, do not forget to "
+		 "also purge the current instance of it.\r\n");
+  }
+}
+
+COMMAND(cmd_mdelete) {
+  char *name = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word", &name))
+    return;
+  do_delete(ch, "mproto", deleteProto, name);
+}
+
+COMMAND(cmd_odelete) {
+  char *name = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word", &name))
+    return;
+  do_delete(ch, "oproto", deleteProto, name);
+}
+
+
+
+//*****************************************************************************
+// Functions for listing different types of data (zones, mobs, objs, etc...)
 //*****************************************************************************
+//
+// returns yes/no if the prototype is abstract or not
+const char *prototype_list_info(PROTO_DATA *data) {
+  static char buf[SMALL_BUFFER];
+  sprintf(buf, "%-50s %3s", 
+	  (*protoGetParents(data) ? protoGetParents(data) : "-------"),
+	  (protoIsAbstract(data)  ? "yes" : "no"));
+  return buf;
+}
+
+// this is used for the header when printing out zone proto info
+#define PROTO_LIST_HEADER \
+"Parents                                       Abstract"
+
+
+COMMAND(cmd_rlist) {
+  do_list(ch, (arg&&*arg?arg:get_key_locale(roomGetClass(charGetRoom(ch)))),
+	  "rproto", PROTO_LIST_HEADER, prototype_list_info);
+}
+
+COMMAND(cmd_mlist) {
+  do_list(ch, (arg&&*arg?arg:get_key_locale(roomGetClass(charGetRoom(ch)))),
+	  "mproto", PROTO_LIST_HEADER, prototype_list_info);
+}
+
+COMMAND(cmd_olist) {
+  do_list(ch, (arg&&*arg?arg:get_key_locale(roomGetClass(charGetRoom(ch)))),
+	  "oproto", PROTO_LIST_HEADER, prototype_list_info);
+}
+
+COMMAND(cmd_mrename) {
+  char *from = NULL, *to = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word word", &from, &to))
+    return;
+  do_rename(ch, "mproto", from, to);
+}
+
+COMMAND(cmd_rrename) {
+  char *from = NULL, *to = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word word", &from, &to))
+    return;
+  if(do_rename(ch, "rproto", from, to)) {
+    do_rename(ch, "reset", from, to);
+    send_to_char(ch, "No not forget to purge any instances of %s already "
+		 "loaded.\r\n", from); 
+  }
+}
+
+COMMAND(cmd_orename) {
+  char *from = NULL, *to = NULL;
+  if(!parse_args(ch, TRUE, cmd, arg, "word word", &from, &to))
+    return;
+  do_rename(ch, "oproto", from, to);
+}
+
+COMMAND(cmd_zlist) {
+  LIST *keys = worldGetZoneKeys(gameworld);
+
+  // first, order all the zones
+  listSortWith(keys, strcasecmp);
+
+  // now, iterate across them all and show them
+  LIST_ITERATOR *zone_i = newListIterator(keys);
+  ZONE_DATA       *zone = NULL;
+  char             *key = NULL;
+
+  send_to_char(ch,
+" {wKey            Name                                             Editors  Timer\r\n"
+"{b--------------------------------------------------------------------------------\r\n{n");
+
+  ITERATE_LIST(key, zone_i) {
+    if( (zone = worldGetZone(gameworld, key)) != NULL) {
+      send_to_char(ch, " {c%-14s %-30s %25s  {w%5d\r\n", key, zoneGetName(zone),
+		   zoneGetEditors(zone), zoneGetPulseTimer(zone));
+    }
+  } deleteListIterator(zone_i);
+  deleteListWith(keys, free);
+  send_to_char(ch, "{g");
+}
+
+
 
+//*****************************************************************************
+// implementation of olc.h
+//*****************************************************************************
 void init_olc2() {
   // install our auxiliary data on the socket so 
   // we can keep track of our olc data
@@ -272,6 +575,9 @@
   extern COMMAND(cmd_mpedit);
   extern COMMAND(cmd_opedit);
   extern COMMAND(cmd_rpedit);
+  extern COMMAND(cmd_dig);
+  extern COMMAND(cmd_fill);
+  extern COMMAND(cmd_instantiate);
   add_cmd("zedit", NULL, cmd_zedit, POS_UNCONCIOUS, POS_FLYING,
 	  "builder", FALSE, TRUE);
   add_cmd("redit", NULL, cmd_redit, POS_UNCONCIOUS, POS_FLYING,
@@ -292,6 +598,44 @@
 	  "scripter", FALSE, TRUE);
   add_cmd("rpedit", NULL, cmd_rpedit, POS_UNCONCIOUS, POS_FLYING,
 	  "scripter", FALSE, TRUE);
+
+  add_cmd("dig", NULL, cmd_dig, POS_STANDING, POS_FLYING,
+	  "builder", FALSE, TRUE);
+  add_cmd("fill", NULL, cmd_fill, POS_STANDING, POS_FLYING,
+	  "builder", FALSE, TRUE);
+  add_cmd("instantiate", NULL, cmd_instantiate, POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, TRUE);
+  add_cmd("purge",      NULL, cmd_purge,    POS_SITTING,  POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("load",       NULL, cmd_load,     POS_SITTING,  POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("rcopy", NULL, cmd_instantiate,   POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, TRUE);
+
+  add_cmd("mlist",      NULL, cmd_mlist,    POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("mdelete",    NULL, cmd_mdelete,  POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("mrename",    NULL, cmd_mrename,  POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("olist",      NULL, cmd_olist,    POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("odelete",    NULL, cmd_odelete,  POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("orename",    NULL, cmd_orename,  POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("rreload",    NULL, cmd_rreload,  POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("rlist",      NULL, cmd_rlist,    POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("rdelete",    NULL, cmd_rdelete,  POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("rrename",    NULL, cmd_rrename,  POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
+  add_cmd("zlist",      NULL, cmd_zlist,    POS_SITTING,  POS_FLYING,
+	  "builder", FALSE, TRUE);
+  add_cmd("zreset",     NULL, cmd_zreset,   POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
 }
 
 void do_olc(SOCKET_DATA *sock,
diff -ruN ../nakedmudv3.1/src/olc2/redit.c src/olc2/redit.c
--- ../nakedmudv3.1/src/olc2/redit.c	Sun Dec  4 20:03:07 2005
+++ src/olc2/redit.c	Sat Jul  1 20:06:58 2006
@@ -1320,6 +1320,283 @@
 }
 
 
+COMMAND(cmd_dig) {
+  ROOM_DATA      *dest = NULL;
+  char     *parsed_dir = NULL;
+  char *parsed_ret_dir = NULL;
+  char        *ret_dir = NULL;
+  char            *dir = NULL;
+  
+  // parse our arguments
+  if(!parse_args(ch, TRUE, cmd, arg, "room word | word",
+		 &dest, &parsed_dir, &parsed_ret_dir))
+    return;
+
+  // figure out our direction
+  if(dirGetAbbrevNum(parsed_dir) != DIR_NONE)
+    dir = strdup(dirGetName(dirGetAbbrevNum(parsed_dir)));
+  // special exit
+  else
+    dir = strdup(parsed_dir);
+
+  // figure out our return direction. First case == special exit
+  if(parsed_ret_dir != NULL)
+    ret_dir = strdup(parsed_ret_dir);
+  else if(dirGetNum(dir) != DIR_NONE)
+    ret_dir = strdup(dirGetName(dirGetOpposite(dirGetNum(dir))));
+  else if(dirGetAbbrevNum(dir) != DIR_NONE)
+    ret_dir = strdup(dirGetName(dirGetOpposite(dirGetAbbrevNum(dir))));
+
+  // make sure we have a return direction
+  if(ret_dir == NULL)
+    send_to_char(ch, "A return direction for the dig could not be found.\r\n");
+
+  // make sure we don't have an exit in the specified direction
+  else if(roomGetExit(charGetRoom(ch), dir) != NULL)
+    send_to_char(ch, "An exit already exists %s -- fill it first!\r\n",
+		 dir);
+
+  // make sure we don't have an exit in the return direction
+  else if(roomGetExit(dest, ret_dir) != NULL)
+    send_to_char(ch, "An exit already exists in the return direction -- fill it first!\r\n");
+
+  // make sure we have edit priviledges
+  else if(!canEditZone(worldGetZone(gameworld, get_key_locale(roomGetClass(charGetRoom(ch)))), ch))
+    send_to_char(ch, "You are not authorized to edit this zone.\r\n");
+
+  // make sure we have edit priviledges for the destination
+  else if(!canEditZone(worldGetZone(gameworld, get_key_locale(roomGetClass(dest))), ch))
+    send_to_char(ch,"You are not authorized to edit the destination zone.\r\n");
+
+  // do the digging
+  else {
+    // get the prototype for our current room and destination
+    PROTO_DATA  *proto_here = 
+      worldGetType(gameworld, "rproto", roomGetClass(charGetRoom(ch)));
+    PROTO_DATA *proto_there = 
+      worldGetType(gameworld, "rproto", roomGetClass(dest));
+
+    // parse a ROOM_OLC out of them both
+    ROOM_OLC  *olc_here = roomOLCFromProto(proto_here);
+    ROOM_OLC *olc_there = roomOLCFromProto(proto_there);
+
+    // make our exits
+    EXIT_DATA  *exit_here = newExit();
+    EXIT_DATA *exit_there = newExit();
+    exitSetTo(exit_here, roomGetClass(dest));
+    exitSetTo(exit_there, roomGetClass(charGetRoom(ch)));
+
+    // link our rooms
+    roomSetExit(roomOLCGetRoom(olc_here), dir, exit_here);
+    roomSetExit(roomOLCGetRoom(olc_there), ret_dir, exit_there);
+
+    // save our changes and reload the rooms
+    save_room_olc(olc_here);
+    save_room_olc(olc_there);
+
+    // garbage collection
+    deleteRoomOLC(olc_here);
+    deleteRoomOLC(olc_there);
+
+    // inform the builder
+    send_to_char(ch, "You link %s [%s] to %s [%s].\r\n",
+		 roomGetClass(charGetRoom(ch)), dir,
+		 roomGetClass(dest), ret_dir);
+  }
+
+  // garbage collection
+  free(dir);
+  free(ret_dir);
+}
+
+COMMAND(cmd_fill) {
+  ROOM_DATA      *dest = NULL;
+  char     *parsed_dir = NULL;
+  char *parsed_ret_dir = NULL;
+  char        *ret_dir = NULL;
+  char            *dir = NULL;
+  
+  // parse our arguments
+  if(!parse_args(ch, TRUE, cmd, arg, "word | word",
+		 &parsed_dir, &parsed_ret_dir))
+    return;
+
+  // figure out our direction
+  if(dirGetAbbrevNum(parsed_dir) != DIR_NONE)
+    dir = strdup(dirGetName(dirGetAbbrevNum(parsed_dir)));
+  // special exit
+  else
+    dir = strdup(parsed_dir);
+
+  // figure out our return direction. First case == special exit
+  if(parsed_ret_dir != NULL)
+    ret_dir = strdup(parsed_ret_dir);
+  else if(dirGetNum(dir) != DIR_NONE)
+    ret_dir = strdup(dirGetName(dirGetOpposite(dirGetNum(dir))));
+  else if(dirGetAbbrevNum(dir) != DIR_NONE)
+    ret_dir = strdup(dirGetName(dirGetOpposite(dirGetAbbrevNum(dir))));
+
+  // make sure we have a return direction
+  if(ret_dir == NULL)
+    send_to_char(ch, "A return direction for fill could not be found.\r\n");
+  // make sure we have the exit
+  else if(!roomGetExit(charGetRoom(ch), dir))
+    send_to_char(ch, "No exit exists %s!\r\n", dir);
+  // make sure the destination exists
+  else if((dest = worldGetRoom(gameworld,exitGetTo(roomGetExit(charGetRoom(ch),
+							       dir)))) == NULL)
+    send_to_char(ch, "No destination exists %s!\r\n", dir);
+  // make sure we have edit priviledges
+  else if(!canEditZone(worldGetZone(gameworld, get_key_locale(roomGetClass(charGetRoom(ch)))), ch))
+    send_to_char(ch, "You are not authorized to edit this zone.\r\n");
+  // make sure we have edit priviledges for the destination
+  else if(!canEditZone(worldGetZone(gameworld, get_key_locale(roomGetClass(dest))), ch))
+    send_to_char(ch,"You are not authorized to edit the destination zone.\r\n");
+
+  // do the digging
+  else {
+    // get the prototype for our current room and destination
+    PROTO_DATA  *proto_here = 
+      worldGetType(gameworld, "rproto", roomGetClass(charGetRoom(ch)));
+    PROTO_DATA *proto_there = 
+      worldGetType(gameworld, "rproto", roomGetClass(dest));
+
+    // parse a ROOM_OLC out of them both
+    ROOM_OLC  *olc_here = roomOLCFromProto(proto_here);
+    ROOM_OLC *olc_there = roomOLCFromProto(proto_there);
+
+    // delete our exits
+    roomRemoveExit(roomOLCGetRoom(olc_here), dir);
+    roomRemoveExit(roomOLCGetRoom(olc_there), ret_dir);
+
+    // save our changes and reload the rooms
+    save_room_olc(olc_here);
+    save_room_olc(olc_there);
+
+    // garbage collection
+    deleteRoomOLC(olc_here);
+    deleteRoomOLC(olc_there);
+
+    // inform the builder
+    send_to_char(ch, "You unlink %s [%s] and %s [%s].\r\n",
+		 roomGetClass(charGetRoom(ch)), dir,
+		 roomGetClass(dest), ret_dir);
+  }
+
+  // garbage collection
+  free(dir);
+  free(ret_dir);
+}
+
+
+//
+// builds a list of all the instantiations in the range provided
+LIST *list_instantiations(const char *name, const char *locale, int times) {
+  LIST         *list = newList();
+  int      i, base_i = 1;
+  char *working_name = strdup(name);
+
+  // see if we have a start number provided
+  //***********
+  // FINISH ME
+  //***********
+
+  // generate our keys
+  for(i = base_i; i < times + base_i; i++) {
+    char fullkey[SMALL_BUFFER];
+    sprintf(fullkey, "%s%s%d@%s", working_name, (i < 10 ? "0" : ""), i, locale);
+    listQueue(list, strdup(fullkey));
+  }
+
+  // garbage collection
+  free(working_name);
+  return list;
+}
+
+
+//
+// checks to see if any of the rooms are already cloned
+bool check_for_instantiations(CHAR_DATA *ch, const char *name, const char *locale, int times) {
+  LIST           *keys = list_instantiations(name, locale, times);
+  LIST_ITERATOR *key_i = newListIterator(keys);
+  char            *key = NULL;
+  bool         success = TRUE;  
+
+  ITERATE_LIST(key, key_i) {
+    // check for the existance
+    if(worldGetType(gameworld, "rproto", key) != NULL) {
+      send_to_char(ch, "A prototype with key %s already exists.", key);
+      success = FALSE;
+      break;
+    }
+  } deleteListIterator(key_i);
+  deleteListWith(keys, free);
+
+  return success;
+}
+
+COMMAND(cmd_instantiate) {
+  ZONE_DATA  *dest_zone = NULL;
+  ZONE_DATA   *src_zone = NULL; 
+  char            *dest = NULL;
+  char             *src = NULL;
+  char dest_locale[SMALL_BUFFER];
+  char   dest_name[SMALL_BUFFER];
+  char  src_locale[SMALL_BUFFER];
+  char    src_name[SMALL_BUFFER];
+  int             times = 1;
+
+  // rcopy <source> <dest> [times]
+  if(!parse_args(ch, TRUE, cmd, arg, "word word | int", &src, &dest, &times))
+    return;
+  // get our locale and name for the source
+  else if(!parse_worldkey_relative(ch, src, src_name, src_locale))
+    send_to_char(ch, "What is the key of the source room?\r\n");
+  // get our locale and name for the dest
+  else if(!parse_worldkey_relative(ch, dest, dest_name, dest_locale))
+    send_to_char(ch, "What is the key of the destination room?\r\n");
+  // make sure the destination zone is editable
+  else if((dest_zone = worldGetZone(gameworld, dest_locale)) == NULL)
+    send_to_char(ch, "No such destination zone exists.\r\n");
+  else if((src_zone = worldGetZone(gameworld, src_locale)) == NULL)
+    send_to_char(ch, "No such source zone exists.\r\n");
+  // make sure we have editing priviledges
+  else if(!canEditZone(dest_zone, ch))
+    send_to_char(ch,"You are not authorized to edit the destination zone.\r\n");
+  // make sure none of the prototypes we'll be making are instantiated
+  else if(!check_for_instantiations(ch, src_name, src_locale, times)) 
+    return;
+  else {
+    // generate our list of keys
+    LIST           *keys = list_instantiations(dest_name, dest_locale, times);
+    LIST_ITERATOR *key_i = newListIterator(keys);
+    char            *key = NULL;
+    bool      resettable = FALSE;
+
+    // check to see if the source room is resettable
+    if(listGetWith(zoneGetResettable(src_zone),
+		   get_key_name(get_fullkey(src_name, src_locale)),
+		   strcasecmp) != NULL)
+      resettable = TRUE;
+
+    // create each of the rooms to be cloned
+    ITERATE_LIST(key, key_i) {
+      ROOM_OLC *data = newRoomOLC();
+      roomOLCSetKey(data, key);
+      resetListSetKey(roomOLCGetResets(data), key);
+      roomOLCSetAbstract(data, FALSE);
+      roomOLCSetResettable(data, resettable);
+      roomOLCSetParents(data, get_fullkey(src_name, src_locale));
+      save_room_olc(data);
+      deleteRoomOLC(data);
+    } deleteListIterator(key_i);
+    deleteListWith(keys, free);
+
+    send_to_char(ch, "You create %d new instantion%s of %s@%s.\r\n",
+		 times, (times == 1 ? "":"s"), src_name, src_locale);
+  }
+}
+
 COMMAND(cmd_redit) {
   ZONE_DATA    *zone = NULL;
   PROTO_DATA  *proto = NULL;
diff -ruN ../nakedmudv3.1/src/parse.c src/parse.c
--- ../nakedmudv3.1/src/parse.c	Sun Dec  4 20:03:08 2005
+++ src/parse.c	Sat Jul  1 20:06:58 2006
@@ -15,6 +15,10 @@
 #include "inform.h"
 #include "parse.h"
 
+// mandatory modules
+#include "scripts/scripts.h"
+#include "scripts/pyexit.h"
+
 
 
 //*****************************************************************************
@@ -36,7 +40,11 @@
 #define PARSE_VAR_BOOL         0
 #define PARSE_VAR_INT          1
 #define PARSE_VAR_DOUBLE       2
-#define PARSE_VAR_POINTER      4
+#define PARSE_VAR_CHAR         4
+#define PARSE_VAR_OBJ          5
+#define PARSE_VAR_ROOM         6
+#define PARSE_VAR_EXIT         7
+#define PARSE_VAR_STRING       8
 
 
 
@@ -575,7 +583,7 @@
   if(found == NULL)
     return NULL;
   else {
-    PARSE_VAR *var = newParseVar(PARSE_VAR_POINTER);
+    PARSE_VAR *var = newParseVar(PARSE_VAR_CHAR);
 
     // if multiple vals were possible, flag it
     var->multiple_possible = tok->all_ok;
@@ -632,7 +640,7 @@
   if(found == NULL)
     return NULL;
   else {
-    PARSE_VAR *var = newParseVar(PARSE_VAR_POINTER);
+    PARSE_VAR *var = newParseVar(PARSE_VAR_OBJ);
 
     // if multiple vals were possible, flag it
     var->multiple_possible = tok->all_ok;
@@ -682,7 +690,7 @@
   if(found == NULL)
     return NULL;
   else {
-    PARSE_VAR *var = newParseVar(PARSE_VAR_POINTER);
+    PARSE_VAR *var = newParseVar(PARSE_VAR_EXIT);
 
     // if multiple vals were possible, flag it
     var->multiple_possible = tok->all_ok;
@@ -731,7 +739,7 @@
   if(room == NULL)
     return NULL;
   else {
-    PARSE_VAR *var = newParseVar(PARSE_VAR_POINTER);
+    PARSE_VAR *var = newParseVar(PARSE_VAR_ROOM);
     var->ptr_val   = room;
     return var;
   }
@@ -885,7 +893,7 @@
 
     // parse out a single word
   case PARSE_TOKEN_WORD: {
-    var = newParseVar(PARSE_VAR_POINTER);
+    var = newParseVar(PARSE_VAR_STRING);
     var->ptr_val    = arg;
     bool multi_word = FALSE;
 
@@ -909,7 +917,7 @@
 
     // copies whatever is left
   case PARSE_TOKEN_STRING:
-    var = newParseVar(PARSE_VAR_POINTER);
+    var = newParseVar(PARSE_VAR_STRING);
     var->ptr_val = arg;
     // skip up the place of the arg...
     while(*arg != '\0')
@@ -1083,7 +1091,11 @@
     case PARSE_VAR_DOUBLE:
       *va_arg(vargs, double *) = one_var->dbl_val;
       break;
-    case PARSE_VAR_POINTER:
+    case PARSE_VAR_STRING:
+    case PARSE_VAR_OBJ:
+    case PARSE_VAR_CHAR:
+    case PARSE_VAR_EXIT:
+    case PARSE_VAR_ROOM:
       *va_arg(vargs, void **) = one_var->ptr_val;
       break;
     // this should never happen...
@@ -1102,10 +1114,171 @@
 }
 
 
+//
+// Goes through the list of variables and make a python list with them
+PyObject *parse_create_py_vars(LIST *variables) {
+  LIST_ITERATOR *var_i = newListIterator(variables);
+  PARSE_VAR   *one_var = NULL;
+  PyObject       *list = PyList_New(0);
+  PyObject      *pyval = NULL;
+
+  // go through each variable and assign to vargs as needed
+  ITERATE_LIST(one_var, var_i) {
+    // first, do our basic type
+    switch(one_var->type) {
+    case PARSE_VAR_BOOL:
+      pyval = Py_BuildValue("b", one_var->bool_val);
+      PyList_Append(list, pyval);
+      Py_DECREF(pyval);
+      break;
+    case PARSE_VAR_INT:
+      pyval = Py_BuildValue("i", one_var->int_val);
+      PyList_Append(list, pyval);
+      Py_DECREF(pyval);
+      break;
+    case PARSE_VAR_DOUBLE:
+      pyval = Py_BuildValue("f", one_var->dbl_val);
+      PyList_Append(list, pyval);
+      Py_DECREF(pyval);
+      break;
+    case PARSE_VAR_STRING:
+      pyval = Py_BuildValue("s", one_var->ptr_val);
+      PyList_Append(list, pyval);
+      Py_DECREF(pyval);
+      break;
+    case PARSE_VAR_OBJ:
+      if(one_var->multiple == FALSE)
+	PyList_Append(list, objGetPyFormBorrowed(one_var->ptr_val));
+      else {
+	pyval = PyList_fromList(one_var->ptr_val, objGetPyForm);
+	PyList_Append(list, pyval);
+	Py_DECREF(pyval);
+      }
+      break;
+    case PARSE_VAR_CHAR:
+      if(one_var->multiple == FALSE)
+	PyList_Append(list, charGetPyFormBorrowed(one_var->ptr_val));
+      else {
+	pyval = PyList_fromList(one_var->ptr_val, charGetPyForm);
+	PyList_Append(list, pyval);
+	Py_DECREF(pyval);
+      }
+      break;
+    case PARSE_VAR_EXIT:
+      pyval = newPyExit(one_var->ptr_val);
+      PyList_Append(list, pyval);
+      Py_DECREF(pyval);
+      break;
+    case PARSE_VAR_ROOM:
+      PyList_Append(list, roomGetPyFormBorrowed(one_var->ptr_val));
+      break;
+    // this should never happen...
+    default:
+      break;
+    }
+    
+    // now see if we have a multi_type
+    if(one_var->disambiguated_type != PARSE_NONE) {
+      pyval = 
+	Py_BuildValue("s", (one_var->disambiguated_type==PARSE_CHAR?"char":
+			    (one_var->disambiguated_type==PARSE_ROOM?"room":
+			     (one_var->disambiguated_type==PARSE_OBJ?"obj":
+			      (one_var->disambiguated_type==PARSE_EXIT?"exit":
+			       NULL)))));
+      PyList_Append(list, pyval);
+      Py_DECREF(pyval);
+    }
+
+    // and if we parsed multiple occurences
+    if(one_var->multiple_possible == TRUE) {
+      pyval = Py_BuildValue("b", one_var->multiple);
+      PyList_Append(list, pyval);
+      Py_DECREF(pyval);
+    }
+  } deleteListIterator(var_i);
+
+  return list;
+}
+
+
 
 //*****************************************************************************
 // implementation of parse.h
 //*****************************************************************************
+int parse_expected_py_args(const char *syntax) {
+  LIST *tokens = NULL;
+  if((tokens = decompose_parse_format(syntax)) == NULL)
+    return -1;
+  int count = 0;
+  LIST_ITERATOR *token_i = newListIterator(tokens);
+  PARSE_TOKEN     *token = NULL;
+  ITERATE_LIST(token, token_i) {
+    if(token->type == PARSE_TOKEN_FLAVOR || token->type == PARSE_TOKEN_OPTIONAL)
+      continue;
+
+    // one for a returnable type
+    count++;
+
+    // one to denote what kind in an ambiguous case
+    if(token->type == PARSE_TOKEN_MULTI)
+      count++;
+
+    // one to denote if we had multiples
+    if(token->all_ok)
+      count++;
+  } deleteListIterator(token_i);
+  deleteListWith(tokens, deleteParseToken);
+
+  return count;
+}
+
+void *Py_parse_args(CHAR_DATA *looker, bool show_errors, const char *cmd, 
+		    char *args, const char *syntax) {
+  char err_buf[SMALL_BUFFER] = "";
+  bool       parse_ok = TRUE;
+  LIST        *tokens = NULL;
+  LIST     *variables = NULL;
+  PyObject      *list = NULL;
+
+  // get our list of tokens
+  if((tokens = decompose_parse_format(syntax)) == NULL) {
+    log_string("Command '%s', format error in argument parsing: %s",cmd,syntax);
+    parse_ok = FALSE;
+  }
+  // try to use our tokens to compose a variable list
+  else if((variables = compose_variable_list(looker, tokens, args, err_buf))
+	  == NULL)
+    parse_ok = FALSE;
+  else {
+    // go through all of our vars and make python forms for them
+    list = parse_create_py_vars(variables);
+
+    // fill up optional spots at the end we didn't parse args for
+    int expected = parse_expected_py_args(syntax);
+    while(PyList_Size(list) < expected)
+      PyList_Append(list, Py_None);
+  }
+
+  // did we encounter an error with the arguments and need to mssg someone?
+  if(tokens != NULL && !parse_ok && show_errors) {
+    // do we have a specific error message?
+    if(*err_buf)
+      send_to_char(looker, "%s\r\n", err_buf);
+    // assume a syntax error
+    else
+      show_parse_syntax_error(looker, cmd, tokens);
+  }
+
+  // clean up our mess
+  if(tokens != NULL)
+    deleteListWith(tokens, deleteParseToken);
+  if(variables != NULL)
+    deleteListWith(variables, deleteParseVar);
+
+  // return our parse status
+  return list;
+}
+
 bool parse_args(CHAR_DATA *looker, bool show_errors, const char *cmd,
 		char *args, const char *syntax, ...) {
   char err_buf[SMALL_BUFFER] = "";
diff -ruN ../nakedmudv3.1/src/parse.h src/parse.h
--- ../nakedmudv3.1/src/parse.h	Sun Dec  4 20:03:08 2005
+++ src/parse.h	Sat Jul  1 20:06:58 2006
@@ -113,4 +113,9 @@
 bool parse_args(CHAR_DATA *looker, bool show_errors, const char *cmd, 
 		char *args, const char *syntax, ...);
 
+//
+// the same as above, but returns a Python list version of the arguments
+void *Py_parse_args(CHAR_DATA *looker, bool show_errors, const char *cmd, 
+		    char *args, const char *syntax);
+
 #endif // PARSE_H
